﻿using System;
using System.Runtime.InteropServices;

namespace ConsoleApp1
{
    [Flags]
    enum SendMessageTimeoutFlags : uint
    {
        SMTO_NORMAL = 0x0,
        SMTO_BLOCK = 0x1,
        SMTO_ABORTIFHUNG = 0x2,
        SMTO_NOTIMEOUTIFNOTHUNG = 0x8,
        SMTO_ERRORONEXIT = 0x20
    }

    internal class Program
    {
        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        public static extern IntPtr SendMessageTimeout(
            IntPtr hWnd, uint Msg, UIntPtr wParam, IntPtr lParam,
            SendMessageTimeoutFlags fuFlags, uint uTimeout, out UIntPtr lpdwResult);

        const uint WM_SETTINGCHANGE = 0x001a;

        static unsafe void Main(string[] args)
        {
            UIntPtr result = new UIntPtr();

            IntPtr hwndBroadcast = new IntPtr(0xffff);
            string text = "Environment";
            fixed (char* ptr = text)
            {
                IntPtr lParam = new IntPtr(ptr);
                IntPtr returnValue = SendMessageTimeout(hwndBroadcast, WM_SETTINGCHANGE, UIntPtr.Zero, lParam,
                    SendMessageTimeoutFlags.SMTO_NORMAL, 1000, out result);

                Console.WriteLine($"{returnValue}: {result}");
            }
        }
    }
}
